Index: src/TrackArtist.h
===================================================================
--- src/TrackArtist.h	(revision 11311)
+++ src/TrackArtist.h	(working copy)
@@ -23,6 +23,15 @@
 #include "Experimental.h"
 #include "Sequence.h"
 
+#include "view/BaseV.h"
+#include "view/VRulerV.h"
+#include "view/TrackV.h"
+#include "view/LabelTrackV.h"
+#include "view/TimeTrackV.h"
+#include "view/NoteTrackV.h"
+#include "view/WaveTrackV.h"
+#include "view/SpecTrackV.h"
+
 class wxDC;
 class wxRect;
 class wxHashTable;
@@ -41,205 +50,49 @@
 typedef unsigned char uchar;
 #endif
 
-class AUDACITY_DLL_API TrackArtist {
+#ifndef REFACTORING_TRACKPANEL_DONE
 
+class AUDACITY_DLL_API TrackArtist :
+virtual public LabelTrackV, 
+virtual public TimeTrackV, 
+virtual public NoteTrackV, 
+virtual public WaveTrackV, 
+virtual public SpecTrackV
+{
  public:
    TrackArtist();
    ~TrackArtist();
 
-   void SetColours();
-   void DrawTracks(TrackList *tracks, Track *start,
+   void UpdatePrefs();
+
+   void DrawTracks(wxEvtHandler *win, TrackList *tracks, Track *start,
                    wxDC & dc, wxRegion & reg,
                    wxRect & r, wxRect & clip, ViewInfo *viewInfo, 
                    bool drawEnvelope, bool drawSamples, bool drawSliders);
 
-   void DrawTrack(const Track *t,
+   void DrawTrack(wxEvtHandler *win, const Track *t,
                   wxDC & dc, const wxRect & r, const ViewInfo *viewInfo, 
                   bool drawEnvelope, bool drawSamples, bool drawSliders,
                   bool hasSolo);
 
-   void DrawVRuler(Track *t, wxDC *dc, wxRect & r);
-
-   void UpdateVRuler(Track *t, wxRect & r);
-
    void SetInset(int left, int top, int right, int bottom);
-
-   void UpdatePrefs();
-
-   void InvalidateSpectrumCache(TrackList *tracks);
-   void InvalidateSpectrumCache(WaveTrack *track);
-   int GetSpectrumMinFreq(int deffreq);
-   int GetSpectrumMaxFreq(int deffreq);
-   int GetSpectrumLogMinFreq(int deffreq);
-   int GetSpectrumLogMaxFreq(int deffreq);
-   int GetSpectrumWindowSize();
-
-#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
-   int GetSpectrumFftSkipPoints();
-#endif
-
-   void SetSpectrumMinFreq(int freq);
-   void SetSpectrumMaxFreq(int freq);
-   void SetSpectrumLogMinFreq(int freq);
-   void SetSpectrumLogMaxFreq(int freq);
-
+   void SetColours();
    void SetBackgroundBrushes(wxBrush unselectedBrush, wxBrush selectedBrush,
-			     wxPen unselectedPen, wxPen selectedPen) {
-     this->unselectedBrush = unselectedBrush;
-     this->selectedBrush = selectedBrush;
-     this->unselectedPen = unselectedPen;
-     this->selectedPen = selectedPen;
-   }
+		                       wxPen unselectedPen, wxPen selectedPen);
 
-   // Helper: draws the "sync-locked" watermark tiled to a rectangle
-   static void DrawSyncLockTiles(wxDC *dc, wxRect r);
-
-   // Helper: draws background with selection rect
-   static void DrawBackgroundWithSelection(wxDC *dc, const wxRect &r,
-         Track *track, wxBrush &selBrush, wxBrush &unselBrush,
-         double sel0, double sel1, double h, double pps);
-
  private:
-
-   //
-   // Lower-level drawing functions
-   // 
-
-   void DrawWaveform(WaveTrack *track,
-                     wxDC & dc, const wxRect & r, const ViewInfo *viewInfo, 
-                     bool drawEnvelope, bool drawSamples, bool drawSliders,
-                     bool dB, bool muted);
-
-   void DrawSpectrum(WaveTrack *track,
-                     wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
-                     bool autocorrelation, bool logF);
-#ifdef USE_MIDI
-   int GetBottom(NoteTrack *t, const wxRect &r);
-   void DrawNoteBackground(NoteTrack *track, wxDC &dc, 
-                           const wxRect &r, const wxRect &sel,
-                           const ViewInfo *viewInfo,
-                           const wxBrush &wb, const wxPen &wp,
-                           const wxBrush &bb, const wxPen &bp,
-                           const wxPen &mp);
-   void DrawNoteTrack(NoteTrack *track,
-                      wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
-                      bool muted);
-#endif // USE_MIDI
-
-   void DrawLabelTrack(LabelTrack *track,
-                       wxDC & dc, const wxRect & r, const ViewInfo *viewInfo);
-
-   void DrawTimeTrack(TimeTrack *track,
-                      wxDC & dc, const wxRect & r, const ViewInfo *viewInfo);
-
-   void DrawTimeSlider(WaveTrack *track,
-                       wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
-                       bool rightwards);
-
-   void DrawClipWaveform(WaveTrack *track, WaveClip *clip,
-                         wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
-                         bool drawEnvelope, bool drawSamples, bool drawSliders,
-                         bool dB, bool muted);
-
-   void DrawClipSpectrum(WaveTrack *track, WaveClip *clip,
-                         wxDC & dc, const wxRect & r, const ViewInfo *viewInfo,
-                         bool autocorrelation, bool logF);
-
-   // Waveform utility functions
-
-   void DrawWaveformBackground(wxDC & dc, const wxRect &r, const double env[],
-                               float zoomMin, float zoomMax, bool dB,
-                               const sampleCount where[],
-                               sampleCount ssel0, sampleCount ssel1,
-                               bool drawEnvelope, bool bIsSyncLockSelected);
-
-   void DrawMinMaxRMS(wxDC & dc, const wxRect & r, const double env[],
-                      float zoomMin, float zoomMax, bool dB,
-                      const float min[], const float max[], const float rms[],
-                      const int bl[], bool showProgress, bool muted);
-
-   void DrawIndividualSamples(wxDC & dc, const wxRect & r,
-                              float zoomMin, float zoomMax, bool dB,
-                              WaveClip *clip,
-                              double t0, double pps, double h,
-                              bool drawSamples, bool showPoints, bool muted);
-
-   void DrawNegativeOffsetTrackArrows(wxDC & dc, const wxRect & r);
-
-   void DrawEnvelope(wxDC & dc, const wxRect & r, const double env[],
-                     float zoomMin, float zoomMax, bool dB);
-   void DrawEnvLine(wxDC & dc, const wxRect & r, int x, int y, int cy, bool top);
-
-   // Preference values
-   float mdBrange;            // "/GUI/EnvdBRange"
-   long mShowClipping;        // "/GUI/ShowClipping"
-   int mLogMaxFreq;           // "/SpectrumLog/MaxFreq"
-   int mLogMinFreq;           // "/SpectrumLog/MinFreq"
-   int mMaxFreq;              // "/Spectrum/MaxFreq"
-   int mMinFreq;              // "/Spectrum/MinFreq"
-   int mWindowSize;           // "/Spectrum/FFTSize"
-   bool mIsGrayscale;         // "/Spectrum/Grayscale"
-
-#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
-   int mFftSkipPoints;        // "/Spectrum/FFTSkipPoints"
-#endif //EXPERIMENTAL_FFT_SKIP_POINTS
-
-#ifdef EXPERIMENTAL_FFT_Y_GRID
-   bool mFftYGrid;            // "/Spectrum/FFTYGrid"
-#endif //EXPERIMENTAL_FFT_Y_GRID
-
-#ifdef EXPERIMENTAL_FIND_NOTES
-   bool mFftFindNotes;        // "/Spectrum/FFTFindNotes"
-   float mFindNotesMinA;      // "/Spectrum/FindNotesMinA"
-   int mNumberOfMaxima;       // "/Spectrum/FindNotesN"
-   bool mFindNotesQuantize;   // "/Spectrum/FindNotesQuantize")
-#endif //EXPERIMENTAL_FIND_NOTES
-   
    int mInsetLeft;
    int mInsetTop;
    int mInsetRight;
    int mInsetBottom;
 
-   wxBrush blankBrush;
-   wxBrush unselectedBrush;
-   wxBrush selectedBrush;
-   wxBrush sampleBrush;
-   wxBrush selsampleBrush;
-   wxBrush dragsampleBrush;// for samples which are draggable.
-   wxBrush muteSampleBrush;
-   wxBrush blankSelectedBrush;
-   wxPen blankPen;
-   wxPen unselectedPen;
-   wxPen selectedPen;
-   wxPen samplePen;
-   wxPen rmsPen;
-   wxPen muteRmsPen;
-   wxPen selsamplePen;
-   wxPen muteSamplePen;
-   wxPen odProgressNotYetPen;
-   wxPen odProgressDonePen;
-   wxPen shadowPen;
-   wxPen clippedPen;
-   wxPen muteClippedPen;
-   wxPen blankSelectedPen;
-
-   Ruler *vruler;
-
-#ifdef EXPERIMENTAL_FFT_Y_GRID
-   bool fftYGridOld;
-#endif //EXPERIMENTAL_FFT_Y_GRID
-
-#ifdef EXPERIMENTAL_FIND_NOTES
-   bool fftFindNotesOld;
-   int findNotesMinAOld;
-   int findNotesNOld;
-   bool findNotesQuantizeOld;
-#endif
+#ifdef EXPERIMENTAL_DRAW_THREAD
+ public:
+   int OnUpdateAfterThreadRunID;
+#endif //EXPERIMENTAL_DRAW_THREAD
 };
 
-extern int GetWaveYPos(float value, float min, float max,
-			  int height, bool dB, bool outer, float dBr, 
-			  bool clip);
+#endif //REFACTORING_TRACKPANEL_DONE
 
 #endif                          // define __AUDACITY_TRACKARTIST__
 
Index: src/TrackPanel.cpp
===================================================================
--- src/TrackPanel.cpp	(revision 11311)
+++ src/TrackPanel.cpp	(working copy)
@@ -313,6 +313,10 @@
    OnCutSelectedTextID,
    OnCopySelectedTextID,
    OnPasteSelectedTextID,
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   OnUpdateAfterThreadRunID,
+#endif //EXPERIMENTAL_DRAW_THREAD
 };
 
 BEGIN_EVENT_TABLE(TrackPanel, wxWindow)
@@ -346,6 +350,10 @@
     EVT_MENU(OnCutSelectedTextID, TrackPanel::OnCutSelectedText)
     EVT_MENU(OnCopySelectedTextID, TrackPanel::OnCopySelectedText)
     EVT_MENU(OnPasteSelectedTextID, TrackPanel::OnPasteSelectedText)
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+    EVT_BUTTON(OnUpdateAfterThreadRunID, TrackPanel::OnUpdateAfterThreadRun)
+#endif //EXPERIMENTAL_DRAW_THREAD
 END_EVENT_TABLE()
 
 /// Makes a cursor from an XPM, uses CursorId as a fallback.
@@ -507,6 +515,9 @@
 
    mTrackArtist = new TrackArtist();
    mTrackArtist->SetInset(1, kTopInset + 1, kLeftInset + 2, 2);
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   mTrackArtist->OnUpdateAfterThreadRunID=OnUpdateAfterThreadRunID;
+#endif //EXPERIMENTAL_DRAW_THREAD
 
    mCapturedTrack = NULL;
    mPopupMenuTarget = NULL;
@@ -3280,30 +3291,30 @@
    spectrum = ((WaveTrack *) track)->GetDisplay() == WaveTrack::SpectrumDisplay;
    spectrumLog=(((WaveTrack *) track)->GetDisplay() == WaveTrack::SpectrumLogDisplay);
    if(spectrum) {
-      min = mTrackArtist->GetSpectrumMinFreq(0);
+      min = mTrackArtist->vrulerv->GetSpectrumMinFreq(0);
       if(min < 0)
          min = 0;
-      max = mTrackArtist->GetSpectrumMaxFreq(8000);
+      max = mTrackArtist->vrulerv->GetSpectrumMaxFreq(8000);
       if(max > rate/2.)
          max = rate/2.;
       windowSize = mTrackArtist->GetSpectrumWindowSize();
 #ifdef EXPERIMENTAL_FFT_SKIP_POINTS
-      fftSkipPoints = mTrackArtist->GetSpectrumFftSkipPoints();
+      fftSkipPoints = mTrackArtist->vrulerv->GetSpectrumFftSkipPoints();
 #endif //EXPERIMENTAL_FFT_SKIP_POINTS
       binSize = rate / windowSize;
       minBins = wxMin(10, windowSize/2); //minimum 10 freq bins, unless there are less
    }
    else
       if(spectrumLog) {
-         min = mTrackArtist->GetSpectrumLogMinFreq(lrint(rate/1000.0));
+         min = mTrackArtist->vrulerv->GetSpectrumLogMinFreq(lrint(rate/1000.0));
          if(min < 1)
             min = 1;
-         max = mTrackArtist->GetSpectrumLogMaxFreq(lrint(rate/2.));
+         max = mTrackArtist->vrulerv->GetSpectrumLogMaxFreq(lrint(rate/2.));
          if(max > rate/2.)
             max = rate/2.;
          windowSize = mTrackArtist->GetSpectrumWindowSize();
 #ifdef EXPERIMENTAL_FFT_SKIP_POINTS
-         fftSkipPoints = mTrackArtist->GetSpectrumFftSkipPoints();
+         fftSkipPoints = mTrackArtist->vrulerv->GetSpectrumFftSkipPoints();
 #endif //EXPERIMENTAL_FFT_SKIP_POINTS
          binSize = rate / windowSize;
          minBins = wxMin(10, windowSize/2); //minimum 10 freq bins, unless there are less
@@ -3455,13 +3466,13 @@
    }
 
    if(spectrum) {
-      mTrackArtist->SetSpectrumMaxFreq(max);
-      mTrackArtist->SetSpectrumMinFreq(min);
+      mTrackArtist->vrulerv->SetSpectrumMaxFreq(max);
+      mTrackArtist->vrulerv->SetSpectrumMinFreq(min);
       mTrackArtist->InvalidateSpectrumCache(mTracks);
    }
    else if(spectrumLog) {
-      mTrackArtist->SetSpectrumLogMaxFreq(max);
-      mTrackArtist->SetSpectrumLogMinFreq(min);
+      mTrackArtist->vrulerv->SetSpectrumLogMaxFreq(max);
+      mTrackArtist->vrulerv->SetSpectrumLogMinFreq(min);
       mTrackArtist->InvalidateSpectrumCache(mTracks);
    }
    else {
@@ -5481,7 +5492,7 @@
    bool sliderFlag     = bMultiToolDown;
 
    // The track artist actually draws the stuff inside each track
-   mTrackArtist->DrawTracks(mTracks, GetProject()->GetFirstVisible(),
+   mTrackArtist->DrawTracks(this, mTracks, GetProject()->GetFirstVisible(),
                             *dc, region, tracksRect, clip, mViewInfo, 
                             envelopeFlag, samplesFlag, sliderFlag);
 
@@ -5561,7 +5572,7 @@
          r.y += kTopInset;
          r.width = GetVRulerWidth();
          r.height -= (kTopInset + 2);
-         mTrackArtist->DrawVRuler(t, dc, r);
+         mTrackArtist->vrulerv->DrawVRuler(t, dc, r);
       }
    }
 
@@ -5844,11 +5855,11 @@
             t->GetHeight() - (kTopInset + 2));
 
    if (t) {
-      mTrackArtist->UpdateVRuler(t, r);
+      mTrackArtist->vrulerv->UpdateVRuler(t, r);
       Track *l = t->GetLink();
       if (l) {
          r.height = l->GetHeight() - (kTopInset + 2);
-         mTrackArtist->UpdateVRuler(l, r);
+         mTrackArtist->vrulerv->UpdateVRuler(l, r);
       }
    }
 }
@@ -7393,6 +7404,32 @@
    RefreshTrack(lt);
 }
 
+#ifdef EXPERIMENTAL_DRAW_THREAD
+
+void TrackPanel::OnUpdateAfterThreadRun(wxCommandEvent &event)
+{
+   TrackUpdateData *data=(TrackUpdateData*)event.GetClientData();
+   wxRect mid=data->mid;
+   wxImage *image=data->image;
+   WaveClip *clip=data->clip;
+   delete data;
+
+   // If we get to this point, the clip is actually visible on the
+   // screen, so remember the display rectangle.
+   clip->SetDisplayRect(mid);
+   wxBitmap converted = wxBitmap(*image);
+   wxMemoryDC memDC;
+
+   memDC.SelectObject(converted);
+   mBackingDC.Blit(mid.x, mid.y, mid.width, mid.height, &memDC, 0, 0, wxCOPY, FALSE);
+   delete image;
+   // Copy it to the display
+   wxClientDC dc(this);
+   dc.Blit(0, 0, mBacking->GetWidth(), mBacking->GetHeight(), &mBackingDC, 0, 0);
+}
+
+#endif //EXPERIMENTAL_DRAW_THREAD
+
 // Small helper class to enumerate all fonts in the system
 // We use this because the default implementation of
 // wxFontEnumerator::GetFacenames() has changed between wx2.6 and 2.8
Index: src/TrackPanel.h
===================================================================
--- src/TrackPanel.h	(revision 11311)
+++ src/TrackPanel.h	(working copy)
@@ -148,8 +148,16 @@
    friend class TrackPanel;
 };
 
+#ifdef EXPERIMENTAL_DRAW_THREAD
+class TrackUpdateData
+{
+public:
+   wxRect mid;
+   wxImage *image;
+   WaveClip *clip;
+};
+#endif //EXPERIMENTAL_DRAW_THREAD
 
-
 const int DragThreshold = 3;// Anything over 3 pixels is a drag, else a click.
 
 
@@ -428,6 +436,10 @@
    void OnCopySelectedText(wxCommandEvent &event);
    void OnPasteSelectedText(wxCommandEvent &event);
 
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   void OnUpdateAfterThreadRun(wxCommandEvent &event);
+#endif //EXPERIMENTAL_DRAW_THREAD
+
    void SetTrackPan(Track * t, LWSlider * s);
    void SetTrackGain(Track * t, LWSlider * s);
 
Index: src/view/BaseV.cpp
===================================================================
--- src/view/BaseV.cpp	(revision 0)
+++ src/view/BaseV.cpp	(working copy)
@@ -0,0 +1,16 @@
+#include "../Audacity.h"
+#include "wx/panel.h"
+#include "BaseV.h"
+
+BaseV::BaseV(void)
+#ifdef REFACTORING_TRACKPANEL_DONE
+:
+wxPanel()
+#endif //REFACTORING_TRACKPANEL_DONE
+{
+}
+
+BaseV::~BaseV(void)
+{
+}
+
Index: src/view/BaseV.h
===================================================================
--- src/view/BaseV.h	(revision 0)
+++ src/view/BaseV.h	(working copy)
@@ -0,0 +1,10 @@
+
+class AUDACITY_DLL_API BaseV
+#ifdef REFACTORING_TRACKPANEL_DONE
+: public wxPanel
+#endif
+{
+public:
+   BaseV(void);
+   ~BaseV(void);
+};
Index: src/view/LabelTrackV.cpp
===================================================================
--- src/view/LabelTrackV.cpp	(revision 0)
+++ src/view/LabelTrackV.cpp	(working copy)
@@ -0,0 +1,26 @@
+#include "../Audacity.h"
+#include "../TrackArtist.h"
+
+LabelTrackV::LabelTrackV(void):
+TrackV()
+{
+}
+
+LabelTrackV::~LabelTrackV(void)
+{
+}
+
+void LabelTrackV::DrawLabelTrack(LabelTrack *track,
+                                 wxDC & dc,
+                                 const wxRect & r,
+                                 const ViewInfo *viewInfo)
+{
+   double sel0 = viewInfo->sel0;
+   double sel1 = viewInfo->sel1;
+   
+   if (!track->GetSelected() && !track->IsSyncLockSelected())
+      sel0 = sel1 = 0.0;
+   
+   track->Draw(dc, r, viewInfo->h, viewInfo->zoom, sel0, sel1);
+}
+
Index: src/view/LabelTrackV.h
===================================================================
--- src/view/LabelTrackV.h	(revision 0)
+++ src/view/LabelTrackV.h	(working copy)
@@ -0,0 +1,11 @@
+
+class AUDACITY_DLL_API LabelTrackV:
+virtual public TrackV
+{
+public:
+   LabelTrackV(void);
+   ~LabelTrackV(void);
+
+   void DrawLabelTrack(LabelTrack *track,
+                       wxDC & dc, const wxRect & r, const ViewInfo *viewInfo);
+};
